<?php
// $PUBLICATIONS an array holding constant information about the publications that are referenced in Appion.
// When adding a new processing package to Appion, this file should be updated with any associated publications
// for proper reference reporting.

$PUBLICATIONS['appion'] = array(
'title' => 'Appion: an integrated, database-driven pipeline to facilitate EM image processing.',
'year' => '2009',
'authorlist' => 'Lander GC, Stagg SM, Voss NR, et al.',
'journal' => 'J Struct Biol.',
'volume' => '166',
'issue' => '1',
'pmid' => '19263523',
'pmcid' => '2775544',
'doi' => '10.1016/j.jsb.2009.01.002',
'logo' => 'img/topbarbackgrnd.jpg',
'pages' => '95-102');

$PUBLICATIONS['eman'] = array(
'title' => 'EMAN: semiautomated software for high-resolution single-particle reconstructions.',
'year' => '1999',
'authorlist' => 'Ludtke SJ, Baldwin PR, Chiu W.',
'journal' => 'J Struct Biol.',
'volume' => '128',
'issue' => '1',
'pmid' => '10600563',
'pmcid' => '',
'doi' => '',
'logo' => 'img/eman_logo.png',
'pages' => '82-97');

$PUBLICATIONS['spider'] = array(
'title' => 'SPIDER and WEB: processing and visualization of images in 3D electron microscopy and related fields.',
'year' => '1996',
'authorlist' => 'Frank J, Radermacher M, Penczek P, Zhu J, Li Y, Ladjadj M, Leith A.',
'journal' => 'J Struct Biol.',
'volume' => '116',
'issue' => '1',
'pmid' => '8742743',
'pmcid' => '',
'doi' => '',
'logo' => 'img/spider_logo.png',
'pages' => '190-9');

$PUBLICATIONS['imagic'] = array(
'title' => 'A New Generation of the IMAGIC Image Processing System.',
'year' => '1996',
'authorlist' => 'van Heel M., Harauz G., Orlova E. V., Schmidt R. & Schatz M',
'journal' => 'J Struct Biol.',
'volume' => '116',
'issue' => '1',
'pmid' => '8742718',
'pmcid' => '',
'doi' => '',
'logo' => 'img/imagic_logo.png',
'pages' => '');

$PUBLICATIONS['xmipp'] = array(
'title' => 'XMIPP: a new generation of an open-source image processing package for electron microscopy',
'year' => '2004',
'authorlist' => 'Sorzano CO, Marabini R, Velázquez-Muriel J, Bilbao-Castro JR, Scheres SH, Carazo JM, Pascual-Montano A.',
'journal' => 'J Struct Biol.',
'volume' => '148',
'issue' => '2',
'pmid' => '15477099',
'pmcid' => '',
'doi' => '10.1016/j.jsb.2004.06.006',
'logo' => 'img/xmipp_logo.png',
'pages' => '');

$PUBLICATIONS['frealign'] = array(
'title' => 'FREALIGN: high-resolution refinement of single particle structures.',
'year' => '2007',
'authorlist' => 'Grigorieff, N.',
'journal' => 'J Struct Biol.',
'volume' => '157',
'issue' => '1',
'pmid' => '16828314',
'pmcid' => '',
'doi' => '10.1016/j.jsb.2006.05.004',
'logo' => 'img/grigorieff_lab.png',
'pages' => '');

$PUBLICATIONS['initmodel'] = array(
'title' => 'A toolbox for ab initio 3-D reconstructions in single-particle electron microscopy.',
'year' => '2010',
'authorlist' => 'Voss NR, Lyumkis D, Cheng A, et al.</i>',
'journal' => 'J Struct Biol.',
'volume' => '169',
'issue' => '3',
'pmid' => '20018246',
'pmcid' => '',
'doi' => '',
'logo' => 'img/topbarbackgrnd.jpg',
'pages' => '');
 
$PUBLICATIONS['imodweightedbackproj'] = array(
'title' => 'Dual-axis tomography: an approach with alignment methods that preserve resolution.',
'year' => '1997',
'authorlist' => 'D.N. Mastronarde',
'journal' => 'J Struct Biol.',
'volume' => '120',
'issue' => '3',
'pmid' => '9441937',
'pmcid' => '',
'doi' => 'doi:10.1006/jsbi.1997.3919',
'logo' => '',
'pages' => '');
 
$PUBLICATIONS['protomo'] = array(
'title' => 'Accurate marker-free alignment with simultaneous geometry determination and reconstruction of tilt series in electron tomography.',
'year' => '2006',
'authorlist' => 'Winkler H, Taylor KA',
'journal' => 'Ultramicroscopy',
'volume' => '106',
'issue' => '3',
'pmid' => '16137829',
'pmcid' => '',
'doi' => 'doi:10.1016/j.ultramic.2005.07.007',
'logo' => '',
'pages' => '');
 
$PUBLICATIONS['imod'] = array(
'title' => 'Computer visualization of three-dimensional image data using IMOD',
'year' => '1996',
'authorlist' => 'Kremer J.R., D.N. Mastronarde and J.R. McIntosh',
'journal' => 'J. Struct. Biol.',
'volume' => '116',
'issue' => '1',
'pmid' => '8742726',
'pmcid' => '',
'doi' => 'doi:10.1006/jsbi.1996.0013',
'logo' => '',
'pages' => '');
	
$PUBLICATIONS['ace'] = array(
'title' => 'ACE: automated CTF estimation.',
'year' => '2005',
'authorlist' => 'Mallick, Carragher, Potter, and Kriegman',
'journal' => 'Ultramicroscopy',
'volume' => '104',
'issue' => '1',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '8-29');
 
$PUBLICATIONS['roseman03'] = array(
'title' => 'Particle finding in electron micrographs using a fast local correlation algorithm.',
'year' => '2003',
'authorlist' => 'Roseman',
'journal' => 'Ultramicroscopy',
'volume' => '94',
'issue' => '3-4',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '225-36');

$PUBLICATIONS['sousa07'] = array(
'title' => 'Ab initio resolution measurement for single particle structures.',
'year' => '2007',
'authorlist' => 'Sousa and Grigorieff',
'journal' => 'J Struct Biol',
'volume' => '157',
'issue' => '1',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '201-10');

$PUBLICATIONS['leginon'] = array(
'title' => 'Automated molecular microscopy: the new Leginon system.',
'year' => '2005',
'authorlist' => 'Suloway, Pulokas, Fellmann, Cheng, Guerra, Quispe, Stagg, Potter, and Carragher',
'journal' => 'J Struct Biol',
'volume' => '151',
'issue' => '1',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '41-60');

$PUBLICATIONS['dog'] = array(
'title' => 'DoG Picker and TiltPicker: tools to facilitate particle selection in single particle electron microscopy.',
'year' => '2009',
'authorlist' => 'Voss, Yoshioka, Radermacher, Potter, and Carragher',
'journal' => 'J Struct Biol',
'volume' => '166',
'issue' => '2',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => '',
'pages' => '205-13');

$PUBLICATIONS['scheres07'] = array(
'title' => 'Disentangling conformational states of macromolecules in 3D-EM through likelihood optimization.',
'year' => '2007',
'authorlist' => 'Scheres, S. H., H. Gao, et al.',
'journal' => 'Nat Methods',
'volume' => '4',
'issue' => '1',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => 'img/xmipp_logo.png',
'pages' => '');

$PUBLICATIONS['scheres10'] = array(
'title' => 'Classification of structural heterogeneity by maximum-likelihood methods.',
'year' => '2010',
'authorlist' => 'Scheres, S. H.',
'journal' => 'Methods Enzymol',
'volume' => '482',
'issue' => '',
'pmid' => '',
'pmcid' => '',
'doi' => '',
'logo' => 'img/xmipp_logo.png',
'pages' => '');



?>